This project welcomes contributions!

Please follow these guidelines when contributing, as it will give your pull 
request the best chance of being accepted:

# Requesting Features/Reporting Bugs

To request a new feature or to report a bug, please open a [new Issue][new-issue].

Please note: This project is **not** actively supported. Opened Issues **may** 
be responded to, but this is not guaranteed.

# Contributing Code

- This project uses [GitHub Flow][github-flow]
- branch off of `main` to start developing (`git checkout -b <your branch>`)
- ensure that your new branch has a descriptive name
- create a remote copy of your new branch (`git push`)
- create a draft [pull request][pull-request]
  to merge your branch with `main` — tag any related or to-close Issues
- when you think you're finished, un-draft your pull request.

# Commits

- This project uses [Conventional Commits][conventional]; and
- keep individual commits as small as possible

# Versioning

- This project uses [Semantic Versioning][semver]

# Translating

- Translations are welcome!

[new-issue]: https://github.com/Rumperuu/Threat-Intelligence-Service/issues/new/choose
[github-flow]: https://githubflow.github.io/
[pull-request]: https://github.com/Rumperuu/Threat-Intelligence-Service/compare
[conventional]: https://www.conventionalcommits.org
[semver]: https://semver.org/
